﻿Option Strict On
Imports System.Data.Linq
Imports System.Data.Linq.Mapping

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Public Class YourName
        Inherits DataContext
        Public Namae As Table(Of Namae)
        Public Sub New()
            MyBase.New("isostore:/yourNameDB.sdf")
        End Sub
    End Class

    <Table()>
    Public Class Namae
        <Column(IsPrimaryKey:=True, IsDbGenerated:=True)>
        Public Property namaeID As Integer

        <Column(CanBeNull:=False)>
        Public Property _namae As String
    End Class

    Dim db As YourName = New YourName()

    Private Sub namaeTextBox_GotFocus(sender As Object, e As System.Windows.RoutedEventArgs) Handles namaeTextBox.GotFocus
        namaeTextBox.Text = String.Empty
    End Sub

    Private Sub addButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles addButton.Click
        If namaeTextBox.Text = String.Empty Then
            MessageBox.Show("データを入力してください")
            Exit Sub
        Else
            Dim nameList As New List(Of Namae)
            Dim reNameList As New List(Of Namae)

            If db.DatabaseExists = False Then db.CreateDatabase()
            nameList.Add(New Namae With {._namae = namaeTextBox.Text})
            'ListBox1.ItemsSource = nameList
            db.Namae.InsertAllOnSubmit(nameList) '(Of Namae)(nameList)
            db.SubmitChanges()


            For Each result In From c In db.Namae Select c
                reNameList.Add(New Namae With {.namaeID = result.namaeID, ._namae = result._namae})
            Next
            ListBox1.ItemsSource = reNameList

        End If
    End Sub

    Private Sub DeleteButton_Click(sender As Object, e As EventArgs)

        Dim delData As String = DirectCast(sender, Button).Tag.ToString

        For Each result In From c In db.Namae Where c.namaeID.Equals(Integer.Parse(delData)) Select c
            db.Namae.DeleteOnSubmit(result)
        Next
        db.SubmitChanges()

        ListBox1.ItemsSource = db.Namae.ToList

    End Sub

End Class
